VERSION 5.00
Begin VB.Form frmRTQuotes 
   Caption         =   "RTQuotes"
   ClientHeight    =   1695
   ClientLeft      =   4020
   ClientTop       =   3945
   ClientWidth     =   2070
   LinkTopic       =   "Form1"
   ScaleHeight     =   1695
   ScaleWidth      =   2070
   Begin VB.CommandButton cmdTest 
      Caption         =   "Go"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   1335
   End
End
Attribute VB_Name = "frmRTQuotes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' -- True constants
Const iNoSecsInDay As Long = 86400

' -- Set values as needed
Const timeout As Integer = 45
Const dollaramount As Integer = 100
Const bDebug As Boolean = True

Private Enum Tick
  Bid = 1
  Ask = 2
  Lst = 4
  High = 6
  Low = 7
  Cls = 8
End Enum

Dim sDate As String
Dim fso As Scripting.FileSystemObject
Dim tsLog As Scripting.TextStream
Dim tsSyms As Scripting.TextStream
Dim bEventReturned As Boolean
Dim bCancelAfterTickRcvd As Boolean
Dim curPrice As Single
Dim iNoQuotLoops As Integer

' -- eSignal variables
Dim WithEvents esignal As IESignal.Hooks
Attribute esignal.VB_VarHelpID = -1
Dim sLastSymbol As String
Dim lHistoryHandle As Long
Dim lLastHistoryCount As Long
Dim aSyms() As String

Private Sub cmdTest_Click()
    
    Call scan

End Sub

Private Sub Form_Load()
  
  Set fso = New Scripting.FileSystemObject
  Set tsLog = fso.OpenTextFile(App.Path & "\RT.log", ForAppending, True)
  Set tsSyms = fso.OpenTextFile(App.Path & "\Prospect List 20030805.csv", ForReading, False)
  
  Set esignal = New IESignal.Hooks
  lHistoryHandle = 0
  lLastHistoryCount = 0
  
  esignal.SetApplication ("gordonrose")
 
End Sub

Private Sub scan()

  Dim bDoPreMarket As Boolean
  Dim bDoMarket As Boolean
  Dim b10AMCheckComplete As Boolean
  Dim Ticker As String
  Dim iNoLoops As Integer
  Dim sPrice As String
  
  Dim dAsk As Double
  Dim dHigh As Double
  Dim t As Tick
  Dim i As Integer
      
  ' -- Build the array of symbols. Normally this is a database operation.
  '    Remove header line
  tsSyms.ReadLine
  i = 0
  Do While Not tsSyms.AtEndOfStream
    
    ReDim Preserve aSyms(i)
    aSyms(i) = Split(tsSyms.ReadLine, ",")(0)
    i = i + 1
    
  Loop
  
  ' -- Pre-market scan -- should start about 8:45
  'curState = PreMarket
  'With rsScan
    bDoPreMarket = True
    iNoQuotLoops = 0
    'Do While bDoPreMarket
    Do While iNoQuotLoops <= 2
    
      '.MoveFirst
      'Do While Not .EOF
      For i = 0 To UBound(aSyms)
        
        ' -- Check the time
        'If Now() > CDate(Format(Date, "MM/DD/YYYY") & " 09:27:00 AM") Then
        '  bDoPreMarket = False
        '  Exit Do
        'End If
        
        ' -- Get the quote and update rec
        'lSecID = .Fields("SecID")
        'Ticker = .Fields("Ticker")
        Ticker = aSyms(i)
        
        ' -- Get off this row to open it for updating
        '.MoveNext
        
        bEventReturned = False
        If bDebug Then tsLog.WriteLine "Req: " & Ticker & " @ " & CStr(Now())
        ' -- 20030806 -- Ran app, created log file included. Stopped app.
        ' -- Restarted. eSignal crashed on first execution of following line.
        esignal.RequestSymbol Ticker, False
        
        ' -- If executed, will the following cancel the quote request?
        '    Should I execute this line here, instead of where quote
        '    is processed?
        'esignal.ReleaseSymbol Ticker
        
        ' -- Could introduce a delay using sleep -- but how would
        '    that effect event handling?
        If eventTimeOut() Then
          ' -- We haven't heard back.
          If bDebug Then tsLog.WriteLine "Timed out waiting for: " & Ticker & " @ " & CStr(Now())
        End If
         
        DoEvents
         
      ' -- Do While Not .EOF
      'Loop
      Next
    
      iNoQuotLoops = iNoQuotLoops + 1
    
    ' -- Do While bDoPreMarket
    Loop
  
  'End With
  
  ' -- Save rs to disk, get report

End Sub

Private Sub esignal_OnQuoteChanged(ByVal sSymbol As String)
  
    Dim quot As IESignal.BasicQuote
    Dim dAsk As Double
    Dim t As Tick
    
    quot = esignal.GetBasicQuote(sSymbol)
    
    ' -- Since the quote request was called with false for the
    '    second argument, seems this shouldn't be necessary
    esignal.ReleaseSymbol sSymbol
      
    If bDebug Then
      tsLog.WriteLine "Rcvd: " & sSymbol & " @ " & CStr(Now())
      tsLog.WriteLine "Last: " & Format(quot.dLast, "####.00")
    End If
    
    'processQuote sSymbol, quot.dAsk, quot.dBid, quot.lAskSize
    
    ' -- Flag to support serial requests for quotes
    '    and avoid running up the symbol limit before
    '    requested quotes are returned
    bEventReturned = True

End Sub

Private Function eventTimeOut() As Boolean

  Dim uStart As Double
  Dim uEnd As Double
  Dim retval As Boolean
  
  ' -- Pause for up to timeout seconds waiting for event to fire
  retval = False
  uStart = CDbl(Now())
  Do While Not bEventReturned
    DoEvents
    If CInt((CDbl(Now()) - uStart) * iNoSecsInDay) >= timeout Then
      retval = True
      Exit Do
    End If
  Loop

  eventTimeOut = retval

End Function


